Package org.apache.sling.auth.oauth_client.spi

# Interface UserInfoProcessor

public interface UserInfoProcessor
Process the user info received from the identity provider and return the credentials that will be returned by the authentication handler. This interface can be implemented to perform custom processing of the user info, such as mapping fields to a specific format or extracting additional information, or to perform other operation with the released tokens.

## Method Summary

Modifier and Type
Method
Description
`@NotNull String`
`connection()`
`@NotNull OidcAuthCredentials`
`process(@Nullable String userInfo, @NotNull String tokenResponse, @NotNull String oidcSubject, @NotNull String idp)`
This method is called by the OIDC authentication handler after the user info and token response have been received from the identity provider.

## Method Details

### process

@NotNull @NotNull OidcAuthCredentials process(@Nullable @Nullable String userInfo, @NotNull @NotNull String tokenResponse, @NotNull @NotNull String oidcSubject, @NotNull @NotNull String idp) throws RuntimeException

This method is called by the OIDC authentication handler after the user info and token response have been received from the identity provider.

Parameters:
  `userInfo` - the user info received from the identity provider, may be null if not available. See: https://openid.net/specs/openid-connect-core-1_0.html#UserInfo
  `tokenResponse` - the token response received from the identity provider, must not be null. See: https://openid.net/specs/openid-connect-core-1_0.html#HybridTokenResponse
  `oidcSubject` - the OIDC subject identifier as defined in ID Token, must not be null
  `idp` - the identity provider identifier as defined in OidcAuthenticationHandler configuration, must not be null
  `userInfo` -
  `tokenResponse` -
  `oidcSubject` -
  `idp` -
Returns:
  the credentials to be returned by the authentication handler, must not be null
Throws:
  `RuntimeException`

### connection

@NotNull @NotNull String connection()